function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { return function () { var Super = _getPrototypeOf(Derived), result; if (_isNativeReflectConstruct()) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import ReactDOM from 'react-dom';
import SelectModalTabPane from './tabPane';

var SelectModalTabs = /*#__PURE__*/function (_React$Component) {
  _inherits(SelectModalTabs, _React$Component);

  var _super = _createSuper(SelectModalTabs);

  function SelectModalTabs(props) {
    var _this;

    _classCallCheck(this, SelectModalTabs);

    _this = _super.call(this, props);
    _this.activeTab = _this.props.children[0];
    _this.refList = [];
    _this.state = {
      activeTabKey: '',
      barWidth: 0,
      translate: 0
    };
    return _this;
  }

  _createClass(SelectModalTabs, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.setPosition(0);
    }
  }, {
    key: "setPosition",
    value: function setPosition(idx) {
      var activeTabEle = this.refList[idx].current;
      this.setState({
        barWidth: activeTabEle.clientWidth,
        translate: activeTabEle.offsetLeft,
        activeTabKey: this.activeTab.key
      });
    }
  }, {
    key: "onClick",
    value: function onClick(tab, idx) {
      if (tab.key !== this.state.activeTabKey) {
        var onChange = this.props.onChange;
        this.activeTab = tab;
        this.setPosition(idx);

        if (onChange) {
          onChange(tab);
        }
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      this.refList = [];
      var _this$props = this.props,
          prefixCls = _this$props.prefixCls,
          children = _this$props.children,
          withResult = _this$props.withResult;
      var _this$state = this.state,
          activeTabKey = _this$state.activeTabKey,
          barWidth = _this$state.barWidth,
          translate = _this$state.translate;
      var tabIndex = 0;
      var tabTitleList = children.map(function (tab, index) {
        var activeCls = '';

        if (tab.key === activeTabKey) {
          tabIndex = index;
          activeCls = 'active';
        }

        var ref = React.createRef();

        _this2.refList.push(ref);

        return /*#__PURE__*/React.createElement("div", {
          className: "tab ".concat(activeCls),
          key: "tab-title-".concat(index),
          onClick: function onClick() {
            _this2.onClick(tab, index);
          },
          ref: ref
        }, tab.props.title);
      });
      return /*#__PURE__*/React.createElement("div", {
        className: prefixCls + (withResult ? ' with-result' : '')
      }, /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-tab-names")
      }, tabTitleList, /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-tab-line-bar"),
        style: {
          transform: "translate(".concat(translate, "px, 0)"),
          width: "".concat(barWidth, "px")
        }
      })), /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-tab-contents"),
        style: {
          marginLeft: "".concat(-tabIndex * 100, "%"),
          width: "".concat(children.length * 100, "%")
        }
      }, children));
    }
  }]);

  return SelectModalTabs;
}(React.Component);

_defineProperty(SelectModalTabs, "defaultProps", {
  prefixCls: 'mkui-modal-tabs'
});

export { SelectModalTabs as default };
SelectModalTabs.TabPane = SelectModalTabPane;
//# sourceMappingURL=tabs.js.map
