function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { return function () { var Super = _getPrototypeOf(Derived), result; if (_isNativeReflectConstruct()) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

import React from 'react';
import ReactDOM from 'react-dom';
var registeredComponents = [];
var handlers = [];
var IGNORE_CLASS = 'ignore-onclickoutside';

var isSourceFound = function isSourceFound(source, localNode) {
  if (source === localNode) {
    return true;
  }

  return source.classList.contains(IGNORE_CLASS);
};

export default (function (WrappedComponent, config) {
  var instance = null;
  return /*#__PURE__*/function (_React$Component) {
    _inherits(_class, _React$Component);

    var _super = _createSuper(_class);

    function _class(props) {
      var _this;

      _classCallCheck(this, _class);

      _this = _super.call(this, props); // this.wrappedRef = React.createRef()

      _this.wrappedRef = null;
      return _this;
    }

    _createClass(_class, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        var fn = this.__outsideClickHandler = function (localNode, eventHandler) {
          return function (event) {
            event.stopPropagation();
            var source = event.target;
            var found = false;

            while (source.parentNode) {
              found = isSourceFound(source, localNode);
              if (found) return;
              source = source.parentNode;
            }

            eventHandler(event);
          };
        }(ReactDOM.findDOMNode(this), this.handleClickOutside.bind(this));

        var pos = registeredComponents.length;
        registeredComponents.push(this);
        handlers[pos] = fn;

        if (!this.props.disableOnClickOutside) {
          this.enableOnClickOutside();
        }
      }
    }, {
      key: "componentWillUnmount",
      value: function componentWillUnmount() {
        this.disableOnClickOutside();
        this.__outsideClickHandler = false;
        var pos = registeredComponents.indexOf(this);

        if (pos > -1) {
          if (handlers[pos]) {
            handlers.splice(pos, 1);
            registeredComponents.splice(pos, 1);
          }
        }
      }
    }, {
      key: "handleClickOutside",
      value: function handleClickOutside(event) {
        if (this.wrappedRef.handleClickOutside) this.wrappedRef.handleClickOutside(event);else if (config && config.handleClickOutside) {
          this.wrappedRef[config.handleClickOutside](event);
        }
      }
    }, {
      key: "enableOnClickOutside",
      value: function enableOnClickOutside() {
        var fn = this.__outsideClickHandler;
        document.addEventListener('mousedown', fn);
        document.addEventListener('touchstart', fn);
      }
    }, {
      key: "disableOnClickOutside",
      value: function disableOnClickOutside() {
        var fn = this.__outsideClickHandler;
        document.removeEventListener('mousedown', fn);
        document.removeEventListener('touchstart', fn);
      }
    }, {
      key: "render",
      value: function render() {
        var _this2 = this;

        return WrappedComponent ? /*#__PURE__*/React.createElement(WrappedComponent, _extends({
          ref: function ref(wrapped) {
            _this2.wrappedRef = instance = wrapped;
          }
        }, this.props, this.state)) : null;
      }
    }], [{
      key: "getInstance",
      value: function getInstance() {
        return instance;
      }
    }]);

    return _class;
  }(React.Component);
});
//# sourceMappingURL=clickOutside.js.map
