function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { return function () { var Super = _getPrototypeOf(Derived), result; if (_isNativeReflectConstruct()) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import PropTypes from 'prop-types';
import { EnhancedTreeSelect } from 'mkui-ext';

var noop = function noop() {};

var AccountingSubject = /*#__PURE__*/function (_React$Component) {
  _inherits(AccountingSubject, _React$Component);

  var _super = _createSuper(AccountingSubject);

  function AccountingSubject() {
    var _this;

    _classCallCheck(this, AccountingSubject);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "apiAdapter", function () {
      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var api = _this.props.api;
      var keyword = options.keywords;
      return new Promise(function (resolve) {
        if (keyword) {
          api(keyword).then(function (res) {
            var searchData = _this.formatSearchData(res || []);

            resolve(searchData);
          });
        } else {
          api().then(function (res) {
            var data = _this.formatData(res || []);

            resolve(data);
          });
        }
      });
    });

    _defineProperty(_assertThisInitialized(_this), "formatData", function (data) {
      data.map(function (item) {
        item.inited = true;
        return item;
      });
      return data;
    });

    _defineProperty(_assertThisInitialized(_this), "formatSearchData", function (data) {
      var searchData = [];

      var loop = function loop(list) {
        list.forEach(function (item) {
          if (item.children) {
            loop(item.children);
          } else {
            searchData.push({
              code: item.code,
              name: item.name,
              fullName: item.fullName
            });
          }
        });
      };

      loop(data);
      return searchData;
    });

    _defineProperty(_assertThisInitialized(_this), "searchResultRender", function (item) {
      return item.fullName;
    });

    return _this;
  }

  _createClass(AccountingSubject, [{
    key: "render",

    /** *******************render************************** */
    value: function render() {
      var _this$props = this.props,
          value = _this$props.value,
          onChange = _this$props.onChange,
          disabled = _this$props.disabled,
          theme = _this$props.theme;
      return /*#__PURE__*/React.createElement(EnhancedTreeSelect, {
        api: this.apiAdapter,
        lazyLoad: true,
        value: value,
        disabled: disabled,
        labelInValue: true,
        allowClear: true,
        placeholder: "\u8BF7\u9009\u62E9",
        searchPlaceholder: "\u8BF7\u8F93\u5165\u540D\u79F0\u3001\u7F16\u7801\u641C\u7D22...",
        onChange: onChange,
        showSearch: true,
        rootName: "\u4F1A\u8BA1\u79D1\u76EE",
        searchResultRender: this.searchResultRender,
        theme: theme
      });
    }
  }]);

  return AccountingSubject;
}(React.Component);

_defineProperty(AccountingSubject, "propTypes", {
  api: PropTypes.func,
  onChange: PropTypes.func,
  value: PropTypes.object,
  disabled: PropTypes.bool,
  theme: PropTypes.string
});

_defineProperty(AccountingSubject, "defaultProps", {
  api: noop,
  onChange: noop,
  value: null,
  disabled: false
});

export default AccountingSubject;
//# sourceMappingURL=AccountingSubject.js.map
