import PropTypes from 'prop-types';
import noop from '../_util/noop';
/** ImageViewer */

export var ImageViewerPropTypes = {
  width: PropTypes.string,
  height: PropTypes.string,
  dataSource: PropTypes.arrayOf(PropTypes.object),
  code: PropTypes.string,
  onChange: PropTypes.func,
  onValidate: PropTypes.func,
  onAdjust: PropTypes.func,
  loading: PropTypes.bool,
  symbol: PropTypes.string,
  prefixCls: PropTypes.string
};
export var ImageViewerDefaultProps = {
  width: '100%',
  height: '100%',
  dataSource: [],
  code: '',
  onChange: noop,
  onValidate: noop,
  onAdjust: noop,
  loading: false,
  symbol: 'CNY',
  prefixCls: 'mkui-image-viewer'
};
/** Topbar */

export var TopbarPropTypes = {
  onZoom: PropTypes.func,
  onRotate: PropTypes.func,
  onDownload: PropTypes.func,
  modalVisible: PropTypes.bool,
  onOpenModal: PropTypes.func,
  validated: PropTypes.bool,
  onValidate: PropTypes.func,
  prefixCls: PropTypes.string
};
export var TopbarDefaultProps = {
  onZoom: noop,
  onRotate: noop,
  onDownload: noop,
  modalVisible: true,
  onOpenModal: noop,
  validated: false,
  onValidate: noop,
  prefixCls: 'mkui-image-viewer-option'
};
/** Navigation */

export var NavigationPropTypes = {
  imgs: PropTypes.array,
  selectKey: PropTypes.number,
  onSwitch: PropTypes.func,
  prefixCls: PropTypes.string
};
export var NavigationDefaultProps = {
  imgs: [],
  selectKey: 0,
  onSwitch: noop,
  prefixCls: 'mkui-image-viewer-nav'
};
/** Viewer */

export var ViewerPropTypes = {
  img: PropTypes.object,
  prefixCls: PropTypes.string
};
export var ViewerDefaultProps = {
  img: {},
  prefixCls: 'mkui-image-viewer-content'
};
/** InvoiceModal */

export var InvoiceModalPropTypes = {
  img: PropTypes.object,
  symbol: PropTypes.string,
  onClose: PropTypes.func,
  onAdjust: PropTypes.func,
  modalVisible: PropTypes.bool,
  prefixCls: PropTypes.string
};
export var InvoiceModalDefaultProps = {
  img: {},
  onClose: noop,
  onAdjust: noop,
  modalVisible: true,
  symbol: '',
  prefixCls: 'mkui-image-viewer'
};
/** DotLoading */

export var DotLoadingPropTypes = {
  text: PropTypes.string,
  prefixCls: PropTypes.string
};
export var DotLoadingDefaultProps = {
  text: '',
  prefixCls: 'mkui-image-viewer'
};
//# sourceMappingURL=PropTypes.js.map
