import React, { Fragment } from 'react';
import classnames from 'classnames';
import { Icon } from 'mkui-fd';
import { TopbarPropTypes, TopbarDefaultProps } from './PropTypes';

var renderExtra = function renderExtra(_ref) {
  var prefixCls = _ref.prefixCls,
      modalVisible = _ref.modalVisible,
      onOpenModal = _ref.onOpenModal,
      validated = _ref.validated,
      onValidate = _ref.onValidate;
  return (
    /*#__PURE__*/
    // eslint-disable-next-line react/jsx-fragments
    React.createElement(Fragment, null, /*#__PURE__*/React.createElement("span", null, " | "), /*#__PURE__*/React.createElement("div", {
      className: classnames("".concat(prefixCls, "-menu"), {
        validated: validated
      }),
      onClick: !validated ? onValidate : undefined
    }, /*#__PURE__*/React.createElement(Icon, {
      type: "authentication",
      className: "menu-icon"
    }), validated ? '已验真' : '点击验真'), /*#__PURE__*/React.createElement("div", {
      style: {
        visibility: modalVisible ? 'hidden' : ''
      },
      className: "".concat(prefixCls, "-menu"),
      onClick: onOpenModal
    }, /*#__PURE__*/React.createElement(Icon, {
      type: "show",
      className: "menu-icon"
    }), "\u67E5\u770B\u8BE6\u60C5"))
  );
};

var Topbar = function Topbar(props) {
  var onZoom = props.onZoom,
      onRotate = props.onRotate,
      onDownload = props.onDownload,
      prefixCls = props.prefixCls;
  return /*#__PURE__*/React.createElement("div", {
    className: prefixCls
  }, /*#__PURE__*/React.createElement(Icon, {
    type: "zoom-in",
    className: "".concat(prefixCls, "-icon"),
    onClick: function onClick() {
      onZoom('zoomin');
    }
  }), /*#__PURE__*/React.createElement(Icon, {
    type: "zoom-out",
    className: "".concat(prefixCls, "-icon"),
    onClick: function onClick() {
      onZoom('zoomout');
    }
  }), /*#__PURE__*/React.createElement(Icon, {
    type: "rotate-right",
    className: "".concat(prefixCls, "-icon"),
    onClick: function onClick() {
      onRotate('clockwise');
    }
  }), /*#__PURE__*/React.createElement(Icon, {
    type: "rotate-left",
    className: "".concat(prefixCls, "-icon"),
    onClick: function onClick() {
      onRotate('anticlockwise');
    }
  }), /*#__PURE__*/React.createElement(Icon, {
    type: "download",
    className: "".concat(prefixCls, "-icon"),
    onClick: onDownload
  }), renderExtra(props));
};

Topbar.propTypes = TopbarPropTypes;
Topbar.defaultProps = TopbarDefaultProps;
export default Topbar;
//# sourceMappingURL=Topbar.js.map
