function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { return function () { var Super = _getPrototypeOf(Derived), result; if (_isNativeReflectConstruct()) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { Component, Fragment } from 'react';
import _ from 'lodash';
import { Spin } from 'mkui-fd';
import { ViewerPropTypes, ViewerDefaultProps } from './PropTypes';
import { getTranslate, registerEvent, unmountEvent, preventDefaultEvent, downloadFromLink } from './utils';
import { TRANSFORM } from './constant';

var Viewer = /*#__PURE__*/function (_Component) {
  _inherits(Viewer, _Component);

  var _super = _createSuper(Viewer);

  /** *******************life cycle************************** */
  function Viewer(props) {
    var _this;

    _classCallCheck(this, Viewer);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "loadFinishHandle", function () {
      _this.setState({
        isFetching: false
      });
    });

    _defineProperty(_assertThisInitialized(_this), "refHandle", function (ref, name) {
      _this[name] = ref;
    });

    _defineProperty(_assertThisInitialized(_this), "onMouseWheel", function (e) {
      var ev = preventDefaultEvent(e);
      var isZoomin = ev.detail ? ev.detail < 0 : ev.wheelDelta > 0;

      _this.setScale(isZoomin);
    });

    _defineProperty(_assertThisInitialized(_this), "onMouseMove", function (e) {
      var img = _this.imgRef;
      var bg = _this.bgRef;

      var _getTranslate = getTranslate(bg, img, e),
          imgPosX = _getTranslate.imgPosX,
          imgPosY = _getTranslate.imgPosY;

      _this.setState({
        left: "".concat(imgPosX, "px"),
        top: "".concat(imgPosY, "px")
      });
    });

    _defineProperty(_assertThisInitialized(_this), "changeZoom", function (actionType) {
      var isZoomin = actionType === 'zoomin';

      _this.setScale(isZoomin);
    });

    _defineProperty(_assertThisInitialized(_this), "changeRotate", function (actionType) {
      var rotate = _this.state.rotate;
      var isClockwise = actionType === 'clockwise';
      var newRotate = isClockwise ? rotate + TRANSFORM.ROTATE_DEG : rotate - TRANSFORM.ROTATE_DEG;

      _this.setState({
        rotate: newRotate
      });
    });

    _defineProperty(_assertThisInitialized(_this), "onDownload", function () {
      var _this$state$img = _this.state.img,
          oriUrl = _this$state$img.oriUrl,
          code = _this$state$img.code;
      downloadFromLink(oriUrl, code);
    });

    _defineProperty(_assertThisInitialized(_this), "setScale", function (isZoomin) {
      var scale = _this.state.scale; // 临界判断

      if (scale < TRANSFORM.MIN_SCALE_RATE && !isZoomin || scale > TRANSFORM.MAX_SCALE_RATE && isZoomin) {
        return;
      }

      var newScale = isZoomin ? scale * TRANSFORM.SCALE_RATE : scale / TRANSFORM.SCALE_RATE;

      _this.setState({
        scale: newScale
      });
    });

    _defineProperty(_assertThisInitialized(_this), "getImageStyle", function () {
      var _this$state = _this.state,
          left = _this$state.left,
          top = _this$state.top,
          rotate = _this$state.rotate,
          scale = _this$state.scale;
      return {
        transform: "translate(".concat(left, ",").concat(top, ") rotate(").concat(rotate, "deg) scale(").concat(scale, ")")
      };
    });

    _defineProperty(_assertThisInitialized(_this), "renderImg", function () {
      var _this$state2 = _this.state,
          isFetching = _this$state2.isFetching,
          img = _this$state2.img;

      var imageStyle = _this.getImageStyle();

      if (img) {
        return (
          /*#__PURE__*/
          // eslint-disable-next-line react/jsx-fragments
          React.createElement(Fragment, null, /*#__PURE__*/React.createElement("img", {
            style: imageStyle,
            ref: function ref(i) {
              _this.refHandle(i, 'imgRef');
            },
            src: img.url,
            onLoad: _this.loadFinishHandle,
            alt: ""
          }), isFetching && /*#__PURE__*/React.createElement(Spin, {
            className: "image-spin",
            size: "large"
          }))
        );
      }
    });

    _this.state = _objectSpread({
      img: {},
      isFetching: true
    }, TRANSFORM.INIT_STATE);
    return _this;
  }

  _createClass(Viewer, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      // 注册鼠标滚轮和指向事件，完成图片的缩放与拖动
      var bg = this.bgRef;
      registerEvent(bg, 'mousewheel', _.throttle(this.onMouseWheel, 100));
      registerEvent(bg, 'mousemove', _.throttle(this.onMouseMove, 100));
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var bg = this.bgRef;
      unmountEvent(bg, 'mousewheel', this.onMouseWheel);
      unmountEvent(bg, 'mousemove', this.onMouseMove);
    }
    /** *******************handle method************************** */

  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var prefixCls = this.props.prefixCls;
      return /*#__PURE__*/React.createElement("div", {
        className: prefixCls
      }, /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-warpper")
      }, /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-warpper-background"),
        ref: function ref(bg) {
          _this2.refHandle(bg, 'bgRef');
        }
      }, this.renderImg())));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      /** 切换图片时 loading & style init */
      if (props.img !== state.img) {
        return _objectSpread({
          img: props.img,
          isFetching: true
        }, TRANSFORM.INIT_STATE);
      }

      return null;
    }
  }]);

  return Viewer;
}(Component);

export { Viewer as default };
Viewer.propTypes = ViewerPropTypes;
Viewer.defaultProps = ViewerDefaultProps;
//# sourceMappingURL=Viewer.js.map
