"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var React = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _mkuiFd = require("mkui-fd");

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { return function () { var Super = _getPrototypeOf(Derived), result; if (_isNativeReflectConstruct()) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var CurrencyInput = /*#__PURE__*/function (_React$Component) {
  _inherits(CurrencyInput, _React$Component);

  var _super = _createSuper(CurrencyInput);

  function CurrencyInput() {
    var _this;

    _classCallCheck(this, CurrencyInput);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "changeHandle", function (number) {
      var onChange = _this.props.onChange;
      onChange(number);
    });

    _defineProperty(_assertThisInitialized(_this), "blurHandle", function (e) {
      var onBlur = _this.props.onBlur;
      var value = Number(_this.parser(e.target.value));
      onBlur(value, e);
    });

    _defineProperty(_assertThisInitialized(_this), "formatter", function (number) {
      return number.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ',');
    });

    _defineProperty(_assertThisInitialized(_this), "parser", function (value) {
      var reg = new RegExp(',', 'g');
      return value.replace(reg, '');
    });

    return _this;
  }

  _createClass(CurrencyInput, [{
    key: "render",
    value: function render() {
      var _rootCls,
          _this2 = this;

      var _this$props = this.props,
          prefixCls = _this$props.prefixCls,
          precision = _this$props.precision,
          symbol = _this$props.symbol,
          placeholder = _this$props.placeholder,
          disabled = _this$props.disabled,
          value = _this$props.value,
          theme = _this$props.theme,
          nonnegative = _this$props.nonnegative;
      var isSymbol = CurrencyInput.allSymbol.includes(symbol);
      var rootCls = (_rootCls = {}, _defineProperty(_rootCls, prefixCls, 1), _defineProperty(_rootCls, "text", !isSymbol), _defineProperty(_rootCls, "symbol", isSymbol), _rootCls);
      var s = CurrencyInput.getSymbol(symbol);
      return /*#__PURE__*/React.createElement("div", {
        className: (0, _classnames["default"])(rootCls)
      }, /*#__PURE__*/React.createElement("span", {
        className: "".concat(prefixCls, "-symbol")
      }, s), /*#__PURE__*/React.createElement(_mkuiFd.InputNumber, {
        max: 999999999999999,
        min: nonnegative ? 0 : undefined,
        value: value,
        placeholder: placeholder,
        precision: precision,
        disabled: disabled,
        onChange: this.changeHandle,
        className: "mk-currency-input-number",
        formatter: function formatter(formattervalue) {
          return _this2.formatter(formattervalue);
        },
        parser: function parser(parseValue) {
          return _this2.parser(parseValue);
        },
        theme: theme,
        onBlur: this.blurHandle
      }));
    }
  }], [{
    key: "getSymbol",
    value: function getSymbol(symbol) {
      return symbol === 'CNY' ? '￥' : symbol;
    }
  }]);

  return CurrencyInput;
}(React.Component);

exports["default"] = CurrencyInput;

_defineProperty(CurrencyInput, "propTypes", {
  prefixCls: _propTypes["default"].string,
  precision: _propTypes["default"].number,
  symbol: _propTypes["default"].string,
  disabled: _propTypes["default"].bool,
  nonnegative: _propTypes["default"].bool,
  onChange: _propTypes["default"].func,
  value: _propTypes["default"].number,
  theme: _propTypes["default"].string,
  onBlur: _propTypes["default"].func
});

_defineProperty(CurrencyInput, "defaultProps", {
  prefixCls: 'mk-currency-input',
  precision: 2,
  symbol: '',
  disabled: false,
  nonnegative: false,
  value: 0,
  theme: undefined,
  onChange: function onChange() {},
  onBlur: function onBlur() {}
});

_defineProperty(CurrencyInput, "allSymbol", ['￥', '$', '€', '￡']);
//# sourceMappingURL=index.js.map
