"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _mkuiFd = require("mkui-fd");

var _mkuiExt = require("mkui-ext");

var _Panel = _interopRequireDefault(require("./Panel"));

var _default2 = _interopRequireDefault(require("../locale-provider/default"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { return function () { var Super = _getPrototypeOf(Derived), result; if (_isNativeReflectConstruct()) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// string | string[] | number | number[] | LabeledValue | LabeledValue[];
function valueType(props, propName, componentName) {
  var basicType = _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number, _propTypes["default"].object]);

  if (props.multiple && props[propName] === '') {
    return new Error("Invalid prop `".concat(propName, "` of type `string` supplied to `").concat(componentName, "`, ") + 'expected `array` when `multiple`');
  } else {
    var validate = _propTypes["default"].oneOfType([_propTypes["default"].arrayOf(basicType), basicType]);

    return validate.apply(void 0, arguments);
  }
}

var Select = /*#__PURE__*/function (_React$Component) {
  _inherits(Select, _React$Component);

  var _super = _createSuper(Select);

  function Select() {
    var _this;

    _classCallCheck(this, Select);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "renderSelect", function (contextLocale) {
      var _this$props = _this.props,
          value = _this$props.value,
          disabled = _this$props.disabled;
      var placeholder = _this.props.placeholder;
      var emptyValue = value === null || typeof value === 'undefined';

      if (emptyValue && disabled) {
        placeholder = contextLocale.none;
      } else {
        placeholder = placeholder ? placeholder : contextLocale.placeholder;
      }

      return /*#__PURE__*/_react["default"].createElement(_mkuiExt.Popedit, _extends({}, _this.props, {
        placeholder: placeholder,
        inputClassName: "mkui-fee-type-input"
      }), /*#__PURE__*/_react["default"].createElement(_Panel["default"], null));
    });

    return _this;
  }

  _createClass(Select, [{
    key: "render",
    value: function render() {
      return /*#__PURE__*/_react["default"].createElement(_mkuiFd.LocaleReceiver, {
        componentName: "FeeTypeInput",
        defaultLocale: _default2["default"].FeeTypeInput
      }, this.renderSelect);
    }
  }]);

  return Select;
}(_react["default"].Component);

_defineProperty(Select, "propTypes", {
  disabled: _propTypes["default"].bool,
  multiple: _propTypes["default"].bool,
  placeholder: _propTypes["default"].string,
  onChange: _propTypes["default"].func,
  data: _propTypes["default"].oneOfType([_propTypes["default"].array, // 支持两种数据赋值方式，直接赋值或lazyLoad
  _propTypes["default"].object]),
  size: _propTypes["default"].string,
  theme: _propTypes["default"].string,
  value: valueType,
  lazyLoad: _propTypes["default"].bool,
  icon: _propTypes["default"].element,
  api: _propTypes["default"].func,
  // 异步加载时会用到
  allowClear: _propTypes["default"].bool
});

_defineProperty(Select, "defaultProps", {
  placeholder: '',
  onChange: null,
  disabled: false,
  multiple: false,
  data: [],
  lazyLoad: false,
  icon: null,
  api: null,
  allowClear: false
});

var _default = Select;
exports["default"] = _default;
//# sourceMappingURL=Select.js.map
