"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _PropTypes = require("./PropTypes");

var _Topbar = _interopRequireDefault(require("./Topbar"));

var _Navigation = _interopRequireDefault(require("./Navigation"));

var _Viewer = _interopRequireDefault(require("./Viewer"));

var _InvoiceModal = _interopRequireDefault(require("./InvoiceModal"));

var _DotLoading = _interopRequireDefault(require("./DotLoading"));

var _constant = require("./constant");

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { return function () { var Super = _getPrototypeOf(Derived), result; if (_isNativeReflectConstruct()) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ImageViewer = /*#__PURE__*/function (_Component) {
  _inherits(ImageViewer, _Component);

  var _super = _createSuper(ImageViewer);

  /** *******************life cycle************************** */
  function ImageViewer(props) {
    var _this;

    _classCallCheck(this, ImageViewer);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "zoomHandle", function (actionType) {
      if (_this.viewer) {
        _this.viewer.changeZoom(actionType);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "rotateHandle", function (actionType) {
      if (_this.viewer) {
        _this.viewer.changeRotate(actionType);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "downloadHandle", function () {
      if (_this.viewer) {
        _this.viewer.onDownload();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "switchHandle", function (type, index) {
      var _this$state = _this.state,
          key = _this$state.key,
          imgs = _this$state.imgs;
      var onChange = _this.props.onChange;
      var maxIndex = imgs.length - 1; // 临界条件

      if (key <= 0 && type === 'prev' || key >= maxIndex && type === 'next') {
        return;
      }

      var newKey = 0;

      switch (type) {
        case 'prev':
          newKey = key - 1;
          break;

        case 'next':
          newKey = key + 1;
          break;

        default:
          newKey = index;
          break;
      }

      var code = imgs[newKey] && imgs[newKey].code;
      onChange(code);
    });

    _defineProperty(_assertThisInitialized(_this), "modalHandle", function () {
      _this.setState(function (state) {
        return {
          modalVisible: !state.modalVisible
        };
      });
    });

    _defineProperty(_assertThisInitialized(_this), "adjustHandle", function () {
      var onAdjust = _this.props.onAdjust;
      var _this$state2 = _this.state,
          imgs = _this$state2.imgs,
          key = _this$state2.key;
      onAdjust(imgs[key].code);
    });

    _defineProperty(_assertThisInitialized(_this), "validateHandle", function () {
      var onValidate = _this.props.onValidate;
      var _this$state3 = _this.state,
          imgs = _this$state3.imgs,
          key = _this$state3.key;
      onValidate(imgs[key].code);
    });

    _defineProperty(_assertThisInitialized(_this), "setSelectKey", function (code) {
      var imgs = _this.state.imgs;
      var index = imgs.findIndex(function (i) {
        return i.code === code;
      });

      if (index > -1) {
        _this.setState({
          key: index,
          modalVisible: true
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "renderContent", function () {
      var _this$state4 = _this.state,
          key = _this$state4.key,
          imgs = _this$state4.imgs,
          modalVisible = _this$state4.modalVisible;
      var symbol = _this.props.symbol;
      return (
        /*#__PURE__*/
        // eslint-disable-next-line react/jsx-fragments
        _react["default"].createElement(_react.Fragment, null, /*#__PURE__*/_react["default"].createElement(_Topbar["default"], {
          onZoom: _this.zoomHandle,
          onRotate: _this.rotateHandle,
          onDownload: _this.downloadHandle,
          modalVisible: modalVisible,
          onOpenModal: _this.modalHandle,
          validated: (0, _utils.getValidateStatis)(imgs[key]),
          onValidate: _this.validateHandle
        }), /*#__PURE__*/_react["default"].createElement(_Viewer["default"], {
          img: imgs[key],
          ref: function ref(v) {
            _this.viewer = v;
          }
        }), /*#__PURE__*/_react["default"].createElement(_Navigation["default"], {
          imgs: imgs,
          selectKey: key,
          onSwitch: _this.switchHandle
        }), /*#__PURE__*/_react["default"].createElement(_InvoiceModal["default"], {
          img: imgs[key],
          symbol: symbol,
          onClose: _this.modalHandle,
          onAdjust: _this.adjustHandle,
          modalVisible: modalVisible
        }))
      );
    });

    _defineProperty(_assertThisInitialized(_this), "renderNone", function () {
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "none-info"
      }, /*#__PURE__*/_react["default"].createElement("img", {
        src: _constant.NO_INVOICE_IMG,
        alt: "NO_INVOICE_IMG",
        className: "noInvoice-img"
      }), /*#__PURE__*/_react["default"].createElement("div", {
        className: "noInvoice-text"
      }, "\u6682\u65E0\u53D1\u7968\u56FE\u7247"));
    });

    _this.state = {
      imgs: [],
      key: 0,
      code: '',
      visible: true,
      modalVisible: true
    };
    return _this;
  }

  _createClass(ImageViewer, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var code = this.props.code;

      if (code) {
        this.setSelectKey(code);
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var preCode = prevProps.code;
      var code = this.props.code;

      if (preCode !== code) {
        this.setSelectKey(code);
      }
    }
    /** *******************handle method************************** */

  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          prefixCls = _this$props.prefixCls,
          className = _this$props.className,
          width = _this$props.width,
          height = _this$props.height,
          loading = _this$props.loading;
      var visible = this.state.visible;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])("".concat(prefixCls), className),
        style: {
          width: width,
          height: height
        }
      }, visible ? this.renderContent() : this.renderNone(), loading && /*#__PURE__*/_react["default"].createElement(_DotLoading["default"], {
        text: "\u6B63\u5728\u8BC6\u522B..."
      }));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      var dataSource = props.dataSource,
          code = props.code;

      if (dataSource.length <= 0) {
        return {
          visible: false
        };
      }

      if (dataSource !== state.imgs) {
        return {
          imgs: dataSource,
          visible: true
        };
      }

      if (code && code !== state.code) {
        return {
          code: code
        };
      }

      return null;
    }
  }]);

  return ImageViewer;
}(_react.Component);

exports["default"] = ImageViewer;
ImageViewer.propTypes = _PropTypes.ImageViewerPropTypes;
ImageViewer.defaultProps = _PropTypes.ImageViewerDefaultProps;
//# sourceMappingURL=ImageViewer.js.map
