"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _moment = _interopRequireDefault(require("moment"));

var _mkuiFd = require("mkui-fd");

var _mkuiExt = require("mkui-ext");

var _PropTypes = require("./PropTypes");

var _utils = require("./utils");

var _constant = require("./constant");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/* eslint-disable react/jsx-props-no-spreading */
var Text = function Text(_ref) {
  var content = _ref.content,
      item = _ref.item,
      symbol = _ref.symbol;

  switch (item) {
    case 'issueDate':
      return (0, _moment["default"])(content[item]).format('YYYY-MM-DD');

    case 'totalTaxAmount':
    case 'totalPriceAmount':
    case 'totalPriceAndTax':
      return /*#__PURE__*/_react["default"].createElement(_mkuiExt.Currency, {
        value: content[item],
        symbol: symbol,
        size: "small"
      });

    default:
      return content[item];
  }
};

var renderInner = function renderInner(content, symbol) {
  return Object.keys(content).map(function (item) {
    return /*#__PURE__*/_react["default"].createElement("p", {
      key: item
    }, /*#__PURE__*/_react["default"].createElement("span", null, _constant.DETAIL_MAPPER[item], ":"), /*#__PURE__*/_react["default"].createElement("span", {
      className: "invoice-info"
    }, /*#__PURE__*/_react["default"].createElement(Text, {
      content: content,
      item: item,
      symbol: symbol
    })));
  });
};

var renderBtn = function renderBtn(img, onAdjust, prefixCls) {
  if ((0, _utils.getValidateStatis)(img)) {
    return /*#__PURE__*/_react["default"].createElement(_mkuiFd.Icon, {
      type: "bs-seal-passed-zh",
      className: "".concat(prefixCls, "-modal-passed-icon")
    });
  } else {
    return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_mkuiFd.Button, {
      type: "primary",
      style: {
        "float": 'right',
        marginTop: 6
      },
      onClick: onAdjust
    }, "\u8C03\u6574"));
  }
};

var InvoiceModal = function InvoiceModal(props) {
  var prefixCls = props.prefixCls,
      img = props.img,
      modalVisible = props.modalVisible,
      onClose = props.onClose,
      onAdjust = props.onAdjust,
      symbol = props.symbol;

  var _pickInvoiceDetail = (0, _utils.pickInvoiceDetail)(img),
      InvoiceContent = _pickInvoiceDetail.InvoiceContent,
      buyerContent = _pickInvoiceDetail.buyerContent;

  var invoiceTypeDesc = img.invoiceTypeDesc;

  if (modalVisible) {
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: "".concat(prefixCls, "-modal")
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: "".concat(prefixCls, "-modal-head")
    }, /*#__PURE__*/_react["default"].createElement("span", null, invoiceTypeDesc), /*#__PURE__*/_react["default"].createElement(_mkuiFd.Icon, {
      onClick: onClose,
      className: "modal-icon",
      type: "close"
    })), /*#__PURE__*/_react["default"].createElement("div", null, renderInner(InvoiceContent, symbol)), /*#__PURE__*/_react["default"].createElement("div", {
      className: "".concat(prefixCls, "-modal-title")
    }, "\u8D2D\u4E70\u65B9"), /*#__PURE__*/_react["default"].createElement("div", {
      className: "".concat(prefixCls, "-modal-buyer")
    }, renderInner(buyerContent)), renderBtn(img, onAdjust, prefixCls));
  }

  return null;
};

InvoiceModal.propTypes = _PropTypes.InvoiceModalPropTypes;
InvoiceModal.defaultProps = _PropTypes.InvoiceModalDefaultProps;
var _default = InvoiceModal;
exports["default"] = _default;
//# sourceMappingURL=InvoiceModal.js.map
