"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _mkuiFd = require("mkui-fd");

var _classnames = _interopRequireDefault(require("classnames"));

var _PropTypes = require("./PropTypes");

var _constant = require("./constant");

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { return function () { var Super = _getPrototypeOf(Derived), result; if (_isNativeReflectConstruct()) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Navigation = /*#__PURE__*/function (_Component) {
  _inherits(Navigation, _Component);

  var _super = _createSuper(Navigation);

  /** *******************life cycle************************** */
  function Navigation(props) {
    var _this;

    _classCallCheck(this, Navigation);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "renderIcon", function (img) {
      if ((0, _utils.getValidateStatis)(img)) {
        return /*#__PURE__*/_react["default"].createElement(_mkuiFd.Icon, {
          type: "authentication",
          className: "authentication-icon"
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "renderNavImg", function () {
      var _this$state = _this.state,
          navImgs = _this$state.navImgs,
          navStartIndex = _this$state.navStartIndex;
      var _this$props = _this.props,
          onSwitch = _this$props.onSwitch,
          selectKey = _this$props.selectKey;
      return navImgs.map(function (img, index) {
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: (0, _classnames["default"])('nav-img', {
            active: selectKey - navStartIndex === index
          }),
          key: img.code
        }, /*#__PURE__*/_react["default"].createElement("img", {
          key: img.code,
          src: img.thumbnail || img.url // className={(selectKey - navStartIndex) === index ? 'img-active' : ''}
          ,
          onClick: function onClick() {
            onSwitch('target', index + navStartIndex);
          },
          alt: img.code
        }), _this.renderIcon(img));
      });
    });

    _defineProperty(_assertThisInitialized(_this), "renderNumber", function () {
      var selectKey = _this.props.selectKey;
      var originImgs = _this.state.originImgs;
      return "".concat(selectKey + 1, " / ").concat(originImgs.length);
    });

    _this.state = {
      originImgs: [],
      navImgs: [],
      navStartIndex: 0
    };
    return _this;
  }

  _createClass(Navigation, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          prefixCls = _this$props2.prefixCls,
          onSwitch = _this$props2.onSwitch;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: prefixCls
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-number")
      }, this.renderNumber()), /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-body")
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-body-prev")
      }, /*#__PURE__*/_react["default"].createElement(_mkuiFd.Icon, {
        className: "arrows-icon",
        type: "left",
        onClick: function onClick() {
          onSwitch('prev');
        }
      })), /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-body-content")
      }, this.renderNavImg()), /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-body-next")
      }, /*#__PURE__*/_react["default"].createElement(_mkuiFd.Icon, {
        className: "arrows-icon",
        type: "right",
        onClick: function onClick() {
          onSwitch('next');
        }
      }))));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      var propsImgs = props.imgs,
          selectKey = props.selectKey;
      var stateImgs = state.originImgs,
          navStartIndex = state.navStartIndex;

      if (propsImgs !== stateImgs) {
        return {
          originImgs: propsImgs,
          navImgs: (0, _utils.getNavImgs)(propsImgs, 0)
        };
      } // 左侧切换时更新 navImages


      if (selectKey < navStartIndex) {
        var step = navStartIndex - selectKey;
        var newStartIndex = 0;

        if (step === 1) {
          newStartIndex = navStartIndex - 1;
        } else {
          var offset = selectKey - 2;
          newStartIndex = offset > 0 ? offset : 0;
        }

        return {
          navStartIndex: newStartIndex,
          navImgs: (0, _utils.getNavImgs)(stateImgs, newStartIndex)
        };
      } // 右侧切换时更新 navImages


      if (selectKey > navStartIndex + _constant.PAGE_SIZE - 1) {
        var _step = selectKey - (navStartIndex + _constant.PAGE_SIZE - 1);

        var _newStartIndex = 0;

        if (_step === 1) {
          _newStartIndex = navStartIndex + 1;
        } else {
          var _offset = selectKey - 2;

          _newStartIndex = _offset < propsImgs.length - _constant.PAGE_SIZE ? _offset : propsImgs.length - _constant.PAGE_SIZE;
        }

        return {
          navStartIndex: _newStartIndex,
          navImgs: (0, _utils.getNavImgs)(stateImgs, _newStartIndex)
        };
      }

      return null;
    }
    /** *******************render method************************** */

  }]);

  return Navigation;
}(_react.Component);

exports["default"] = Navigation;
Navigation.propTypes = _PropTypes.NavigationPropTypes;
Navigation.defaultProps = _PropTypes.NavigationDefaultProps;
//# sourceMappingURL=Navigation.js.map
