"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DotLoadingDefaultProps = exports.DotLoadingPropTypes = exports.InvoiceModalDefaultProps = exports.InvoiceModalPropTypes = exports.ViewerDefaultProps = exports.ViewerPropTypes = exports.NavigationDefaultProps = exports.NavigationPropTypes = exports.TopbarDefaultProps = exports.TopbarPropTypes = exports.ImageViewerDefaultProps = exports.ImageViewerPropTypes = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _noop = _interopRequireDefault(require("../_util/noop"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/** ImageViewer */
var ImageViewerPropTypes = {
  width: _propTypes["default"].string,
  height: _propTypes["default"].string,
  dataSource: _propTypes["default"].arrayOf(_propTypes["default"].object),
  code: _propTypes["default"].string,
  onChange: _propTypes["default"].func,
  onValidate: _propTypes["default"].func,
  onAdjust: _propTypes["default"].func,
  loading: _propTypes["default"].bool,
  symbol: _propTypes["default"].string,
  prefixCls: _propTypes["default"].string
};
exports.ImageViewerPropTypes = ImageViewerPropTypes;
var ImageViewerDefaultProps = {
  width: '100%',
  height: '100%',
  dataSource: [],
  code: '',
  onChange: _noop["default"],
  onValidate: _noop["default"],
  onAdjust: _noop["default"],
  loading: false,
  symbol: 'CNY',
  prefixCls: 'mkui-image-viewer'
};
/** Topbar */

exports.ImageViewerDefaultProps = ImageViewerDefaultProps;
var TopbarPropTypes = {
  onZoom: _propTypes["default"].func,
  onRotate: _propTypes["default"].func,
  onDownload: _propTypes["default"].func,
  modalVisible: _propTypes["default"].bool,
  onOpenModal: _propTypes["default"].func,
  validated: _propTypes["default"].bool,
  onValidate: _propTypes["default"].func,
  prefixCls: _propTypes["default"].string
};
exports.TopbarPropTypes = TopbarPropTypes;
var TopbarDefaultProps = {
  onZoom: _noop["default"],
  onRotate: _noop["default"],
  onDownload: _noop["default"],
  modalVisible: true,
  onOpenModal: _noop["default"],
  validated: false,
  onValidate: _noop["default"],
  prefixCls: 'mkui-image-viewer-option'
};
/** Navigation */

exports.TopbarDefaultProps = TopbarDefaultProps;
var NavigationPropTypes = {
  imgs: _propTypes["default"].array,
  selectKey: _propTypes["default"].number,
  onSwitch: _propTypes["default"].func,
  prefixCls: _propTypes["default"].string
};
exports.NavigationPropTypes = NavigationPropTypes;
var NavigationDefaultProps = {
  imgs: [],
  selectKey: 0,
  onSwitch: _noop["default"],
  prefixCls: 'mkui-image-viewer-nav'
};
/** Viewer */

exports.NavigationDefaultProps = NavigationDefaultProps;
var ViewerPropTypes = {
  img: _propTypes["default"].object,
  prefixCls: _propTypes["default"].string
};
exports.ViewerPropTypes = ViewerPropTypes;
var ViewerDefaultProps = {
  img: {},
  prefixCls: 'mkui-image-viewer-content'
};
/** InvoiceModal */

exports.ViewerDefaultProps = ViewerDefaultProps;
var InvoiceModalPropTypes = {
  img: _propTypes["default"].object,
  symbol: _propTypes["default"].string,
  onClose: _propTypes["default"].func,
  onAdjust: _propTypes["default"].func,
  modalVisible: _propTypes["default"].bool,
  prefixCls: _propTypes["default"].string
};
exports.InvoiceModalPropTypes = InvoiceModalPropTypes;
var InvoiceModalDefaultProps = {
  img: {},
  onClose: _noop["default"],
  onAdjust: _noop["default"],
  modalVisible: true,
  symbol: '',
  prefixCls: 'mkui-image-viewer'
};
/** DotLoading */

exports.InvoiceModalDefaultProps = InvoiceModalDefaultProps;
var DotLoadingPropTypes = {
  text: _propTypes["default"].string,
  prefixCls: _propTypes["default"].string
};
exports.DotLoadingPropTypes = DotLoadingPropTypes;
var DotLoadingDefaultProps = {
  text: '',
  prefixCls: 'mkui-image-viewer'
};
exports.DotLoadingDefaultProps = DotLoadingDefaultProps;
//# sourceMappingURL=PropTypes.js.map
