"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _mkuiFd = require("mkui-fd");

var _PropTypes = require("./PropTypes");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var renderExtra = function renderExtra(_ref) {
  var prefixCls = _ref.prefixCls,
      modalVisible = _ref.modalVisible,
      onOpenModal = _ref.onOpenModal,
      validated = _ref.validated,
      onValidate = _ref.onValidate;
  return (
    /*#__PURE__*/
    // eslint-disable-next-line react/jsx-fragments
    _react["default"].createElement(_react.Fragment, null, /*#__PURE__*/_react["default"].createElement("span", null, " | "), /*#__PURE__*/_react["default"].createElement("div", {
      className: (0, _classnames["default"])("".concat(prefixCls, "-menu"), {
        validated: validated
      }),
      onClick: !validated ? onValidate : undefined
    }, /*#__PURE__*/_react["default"].createElement(_mkuiFd.Icon, {
      type: "authentication",
      className: "menu-icon"
    }), validated ? '已验真' : '点击验真'), /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        visibility: modalVisible ? 'hidden' : ''
      },
      className: "".concat(prefixCls, "-menu"),
      onClick: onOpenModal
    }, /*#__PURE__*/_react["default"].createElement(_mkuiFd.Icon, {
      type: "show",
      className: "menu-icon"
    }), "\u67E5\u770B\u8BE6\u60C5"))
  );
};

var Topbar = function Topbar(props) {
  var onZoom = props.onZoom,
      onRotate = props.onRotate,
      onDownload = props.onDownload,
      prefixCls = props.prefixCls;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: prefixCls
  }, /*#__PURE__*/_react["default"].createElement(_mkuiFd.Icon, {
    type: "zoom-in",
    className: "".concat(prefixCls, "-icon"),
    onClick: function onClick() {
      onZoom('zoomin');
    }
  }), /*#__PURE__*/_react["default"].createElement(_mkuiFd.Icon, {
    type: "zoom-out",
    className: "".concat(prefixCls, "-icon"),
    onClick: function onClick() {
      onZoom('zoomout');
    }
  }), /*#__PURE__*/_react["default"].createElement(_mkuiFd.Icon, {
    type: "rotate-right",
    className: "".concat(prefixCls, "-icon"),
    onClick: function onClick() {
      onRotate('clockwise');
    }
  }), /*#__PURE__*/_react["default"].createElement(_mkuiFd.Icon, {
    type: "rotate-left",
    className: "".concat(prefixCls, "-icon"),
    onClick: function onClick() {
      onRotate('anticlockwise');
    }
  }), /*#__PURE__*/_react["default"].createElement(_mkuiFd.Icon, {
    type: "download",
    className: "".concat(prefixCls, "-icon"),
    onClick: onDownload
  }), renderExtra(props));
};

Topbar.propTypes = _PropTypes.TopbarPropTypes;
Topbar.defaultProps = _PropTypes.TopbarDefaultProps;
var _default = Topbar;
exports["default"] = _default;
//# sourceMappingURL=Topbar.js.map
