"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _layout = _interopRequireDefault(require("../_layout"));

var _util = _interopRequireDefault(require("../_layout/util"));

var _AutoHeight = _interopRequireDefault(require("./AutoHeight"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { return function () { var Super = _getPrototypeOf(Derived), result; if (_isNativeReflectConstruct()) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Layout = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(Layout, _React$PureComponent);

  var _super = _createSuper(Layout);

  function Layout() {
    _classCallCheck(this, Layout);

    return _super.apply(this, arguments);
  }

  _createClass(Layout, [{
    key: "render",

    /** *******************static************************** */
    value: function render() {
      var _this$props = this.props,
          prefixCls = _this$props.prefixCls,
          hasHead = _this$props.hasHead,
          children = _this$props.children;
      var wrapperCls = (0, _classnames["default"])("".concat(prefixCls), _defineProperty({}, "".concat(prefixCls, "-has-head"), hasHead === true));
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: wrapperCls
      }, children);
    }
  }]);

  return Layout;
}(_react["default"].PureComponent);

_defineProperty(Layout, "propTypes", {
  prefixCls: _propTypes["default"].string,
  hasHead: _propTypes["default"].bool
});

_defineProperty(Layout, "defaultProps", {
  prefixCls: 'mkui-layout-list',
  hasHead: false
});

var Header = (0, _util["default"])({
  prefixCls: 'mkui-layout-list-header'
})(_layout["default"]);
var Content = (0, _util["default"])({
  prefixCls: 'mkui-layout-list-content'
})(_layout["default"]);
var ToolBar = (0, _util["default"])({
  prefixCls: 'mkui-layout-list-content-toolbar'
})(_layout["default"]);
var Filter = (0, _util["default"])({
  prefixCls: 'mkui-layout-list-content-filter'
})(_layout["default"]);
var Table = (0, _util["default"])({
  prefixCls: 'mkui-layout-list-content-table'
})(_layout["default"]);
Content.ListToolBar = ToolBar;
Content.ListFilterWrapper = Filter;
Content.ListTableWrapper = Table;
Layout.ListHeader = Header;
Layout.ListContent = Content;
Layout.AutoHeight = _AutoHeight["default"];
var _default = Layout;
exports["default"] = _default;
//# sourceMappingURL=LayoutList.js.map
